#define MAX_ECHO_FRAMES		32	//half a second long echo buffer

unsigned char echo1_volduty[MAX_ECHO_FRAMES];
unsigned int  echo1_period [MAX_ECHO_FRAMES];
unsigned char echo2_volduty[MAX_ECHO_FRAMES];
unsigned int  echo2_period [MAX_ECHO_FRAMES];

unsigned int echo_len;
unsigned int echo_ptr;
unsigned char echo_fade;



void echo_init(void)
{
	memfill(echo1_volduty,0,sizeof(echo1_volduty));
	memfill(echo1_period ,0,sizeof(echo1_period));
	memfill(echo2_volduty,0,sizeof(echo2_volduty));
	memfill(echo2_period ,0,sizeof(echo2_period));
	
	echo_len=20;
	echo_ptr=0;
	echo_fade=16;
}



void echo_send(unsigned char chn,unsigned char vol,unsigned char duty,unsigned int period)
{
	unsigned char evol,eduty,volduty;
	unsigned int eperiod;
	
	if(!chn)
	{
		evol   =echo1_volduty[echo_ptr]&0x0f;
		eduty  =echo1_volduty[echo_ptr]&0xc0;
		eperiod=echo1_period [echo_ptr];
	}
	else
	{
		evol   =echo2_volduty[echo_ptr]&0x0f;
		eduty  =echo2_volduty[echo_ptr]&0xc0;
		eperiod=echo2_period [echo_ptr];
	}

	if(vol>evol)
	{
		volduty=vol;
		
		if(volduty>=echo_fade*2) volduty-=echo_fade*2; else volduty=0;
		
		if(duty<0xff)
		{
			volduty|=duty;
		}
		else
		{
			volduty|=2<<6;
			period<<=1;
		}
		
		if(!chn)
		{
			echo1_volduty[echo_ptr]=volduty;
			echo1_period [echo_ptr]=period;
		}
		else
		{
			echo2_volduty[echo_ptr]=volduty;
			echo2_period [echo_ptr]=period;
		}
	}
}



void echo_update(void)
{
	unsigned char n,vol,duty;
	unsigned int period;
	
	++echo_ptr;
	
	if(echo_ptr>=echo_len) echo_ptr=0;
	
	vol   =echo1_volduty[echo_ptr]&0x0f;
	duty  =echo1_volduty[echo_ptr]&0xc0;
	period=echo1_period [echo_ptr];

	if(vol>=pulse1_vol)
	{
		pulse1_vol=vol;
		pulse1_duty=duty;
		pulse1_period=period;
	}
	
	vol   =echo2_volduty[echo_ptr]&0x0f;
	duty  =echo2_volduty[echo_ptr]&0xc0;
	period=echo2_period [echo_ptr];

	if(vol>=pulse2_vol)
	{
		pulse2_vol=vol;
		pulse2_duty=duty;
		pulse2_period=period;
	}
	
	n=echo1_volduty[echo_ptr]&0x0f;
	
	if(n>=echo_fade) n-=echo_fade; else n=0;
	
	echo1_volduty[echo_ptr]=(echo1_volduty[echo_ptr]&0xc0)|n;
	
	n=echo2_volduty[echo_ptr]&0x0f;
	
	if(n>=echo_fade) n-=echo_fade; else n=0;
	
	echo2_volduty[echo_ptr]=(echo2_volduty[echo_ptr]&0xc0)|n;
}
