#define ENV_STOP	125
#define ENV_LOOP	126
#define ENV_END		127


struct env_struct {
	const signed char* data;
	unsigned char ptr;
	unsigned char loop;
	unsigned char stop;
	signed char out;
};



void __fastcall__ env_set_data(struct env_struct* env,const signed char* data)
{
	env->data=data;
}



void __fastcall__ env_start(struct env_struct* env)
{
	env->ptr=0;
	env->loop=0;
	env->stop=FALSE;
	env->out=0;
}



void __fastcall__ env_stop(struct env_struct* env)
{
	env->stop=TRUE;
	env->out=0;
}



void __fastcall__ env_update(struct env_struct* env)
{
	signed char n;
	
	if(!env||!env->data||env->stop) return;
	
	while(1)
	{
		n=env->data[env->ptr];

		if(n==ENV_LOOP)
		{
			env->loop=env->ptr++;
			continue;
		}
		
		if(n==ENV_STOP)
		{
			env->stop=TRUE;
			return;
		}
		
		if(n==ENV_END)
		{
			env->ptr=env->loop;
			continue;
		}
		
		env->out=n;
		++env->ptr;
		break;
	}
}
